function sl_customization(cm)
cm.addCustomMenuFcn('Simulink:ContextMenu', @registerLineTraceMenu);
end

%%
function schemaFcns = registerLineTraceMenu()
schemaFcns = { @registerLineTraceMenu_s };
end

%% ej[̓o^֐
function schema = registerLineTraceMenu_s( ~ )
schema = sl_action_schema;

schema.label = sprintf( 'Lineg[X');
schema.callback = @linetrace;
end

function linetrace(callbackInfo)

% Iꂽ̎擾
tmp = find_system(callbackInfo.uiObject.Handle, ...
                    'findall','on','LookUnderMasks','off', ...
                    'Type', 'Line', 'Selected', 'on');

% IꂽAnCCgubN̈ꗗ쐬
hilite_blocks = []; % nCCgubÑnhXg
for i = 1 : length(tmp)
    % M tmp(i) ̐ڑ|[ĝALȕ
    port_handle = get_param(tmp(i), 'DstPortHandle');
    port_handle = port_handle( port_handle ~= -1 );     % |[g(-1)O

    % ڑ|[gAnCCgubN̈ꗗ쐬
    %   ڑ悪TuVXe̓̓|[g̏ꍇ  TuVXe̊YInportnCCg
    %   ڑ悪o̓|[g̏ꍇ  TuVXeO̊YMnCCg
    %   ڑ悪ȊȌꍇ  ڑ̃ubNnCCg
    for j = 1 : length(port_handle)
        % nCCgubN擾
        port_parent = get_param(port_handle(j), 'Parent');  % |[ĝubNi邢̓TuVXej
        if strcmp(get_param(port_parent, 'Type'), 'block')
            % ΏۂubN̏ꍇ

            if strcmp(get_param(port_parent, 'BlockType'), 'SubSystem')
                % ΏۂTuVXȅꍇ
                port = find_system(port_parent, 'Port', int2str(get_param(port_handle(j), 'PortNumber')), 'BlockType', 'Inport');
                hilite_blocks( end + 1 ) = get_param( cell2mat( port ), 'Handle' ); %#ok<AGROW>
            else
                % ΏۂTuVXełȂAPȂubN̏ꍇ
                
                if strcmp( get_param( port_parent, 'BlockType' ), 'Outport' )
                    % ꂪOutport̏ꍇ
                    parent_system = get_param( port_parent, 'Parent' ); % eTuVXe
                    if strcmp( get_param( parent_system, 'type' ), 'block_diagram' )
                        % ŏʂOutportł΁AnCCg
                        hilite_blocks( end + 1 ) = get_param( port_parent, 'Handle' ); %#ok<AGROW>
                    else
                        % ŏʂOutportłȂ΁A
                        % ɂȂM擾
                        portNumber = str2num( get_param( port_parent, 'Port' ) ); %#ok<ST2NM>
                        portHandles = get_param( get_param( port_parent, 'Parent' ), 'PortHandles' );   % eTuVXẽ|[gnh
                        outport = portHandles.Outport( portNumber );      % Yo̓|[g
                        hilite_blocks( end + 1 ) = get_param( outport, 'Line' ); %#ok<AGROW>
                    end
                else
                    % Outportł͂Ȃꍇ
                    % ̃ubNgnCCgΏۂƂ
                    hilite_blocks( end + 1 ) = get_param( port_parent, 'Handle' ); %#ok<AGROW>
                end
            end
        end
    end
end

% hilite_blocksŎw肳ꂽ̂nCCg
hilite_blocks = unique( hilite_blocks );                % d菜
hilite_blocks = hilite_blocks( hilite_blocks ~= -1 );   % nh(-1)O
for j = 1:length( hilite_blocks )
    % ΏۃubN
    target = hilite_blocks( j );

    % ubN̂VXeJ
    open_system( get_param( target, 'Parent' ) );
    
    % _ł
    if strcmp( get_param( target, 'type' ), 'block' )
        % ubN̏ꍇ
        % ݂̔wiF擾
        bgColor = get_param( target, 'BackgroundColor');

        % wiF_ł
        for x = 1:4
            set_param( target, 'BackgroundColor', 'red' );
            pause( 0.3 );
            set_param( target, 'BackgroundColor', 'white' );
            pause( 0.3 );
        end

        % wiFɖ߂
        set_param( target, 'BackgroundColor', bgColor );
    else
        % M̏ꍇ
        for x = 1:4
            set_param( target, 'selected', 'on' );
            pause( 0.3 );
            set_param( target, 'selected', 'off' );
            pause( 0.3 );
        end
    end

end

end
